![MikroE](http://www.mikroe.com/img/designs/beta/logo_small.png)

---

# UART

Code developed for [Fusion for STM32 v8](https://www.mikroe.com/fusion-for-stm32) and it can be used on other MIKROE development boards as well. Code was developed with purpose of easier understanding function for UART module.

---

- **Author**      : MIKROE
- **Version**     : 2.0.0.0
- **Date**        : January 2023.

---

## Software Support

We provide code for demonstrating the usage of functions contained in libraries *MikroSDK.Driver.UART* and *MikroSDK.Driver.GPIO.Out*.

### Functions Description

All functions used in main project are located in libraries *MikroSDK.Driver.UART* and *MikroSDK.Driver.GPIO.Out*.

Functions:

- `void uart_configure_default( uart_config_t *config );` - Configures `uart_config_t` structure to default initialization values.
- `err_t uart_open( uart_t *obj, uart_config_t *config );` - Opens the UART driver object on selected pins.
- `err_t uart_set_baud( uart_t *obj, uint32_t baud );` - Sets baud rate to specified `baud` value.
- `err_t uart_set_parity( uart_t *obj, uart_parity_t parity );` - Sets parity scheme to be used by the UART driver.
- `err_t uart_set_stop_bits( uart_t *obj, uart_stop_bits_t stop );` - Sets the number of stop bits to be used by the UART driver.
- `err_t uart_set_data_bits( uart_t *obj, uart_data_bits_t bits );` - Sets the number of data bits to be used by the UART driver.
- `err_t uart_print( uart_t *obj, char *text );` - Print the string pointed to by `text`.
- `err_t uart_println( uart_t *obj, char *text );` - Print the string pointed to by `text` and append new line at the end.
- `void uart_clear( uart_t *obj );` - Discards all characters from the output and input buffer.
- `void uart_set_blocking( uart_t *obj, bool blocking );` - Sets the UART driver to work in blocking/non-blocking mode.
- `err_t uart_read( uart_t *obj, uint8_t *buffer, size_t size );` - Reads at most `size` bytes of data from the device into `buffer`.
- `err_t uart_write( uart_t *obj, uint8_t *buffer, size_t size );` - Writes at most `size` bytes of data from `buffer` to the device.

## Hardware support

![board](./board.png)

This code was developed on *Fusion for STM32 v8* board.

For this hardware to work according to program, it is necessary to connect USB-UART port to your PC and to turn on RX and TX switches (right half of the USB/UART section).

---
